// HTML2EMail
// server side email processing
// (c)2002,2003 Oliver Michalak / werk01.de

var fileList = new Array();

function processServer (srcFilename) {
	fileList = new Array();
	if (!app.setProgress (0)) {
		processBreak = true;
		return true;
	}
	processObject = 0;
	processFile = srcFilename.substr(srcFilename.lastIndexOf('/')+1);

	// get source...
	var srcFile = JSXFile (srcFilename);
	if (!srcFile.exists)
		return false;
	// create local folder...
	var destFoldername = srcFilename.substr (0, srcFilename.lastIndexOf('.'))+h2eServer.padFolder.value;
	var destFolder = JSXFile (destFoldername);
	if (destFolder.exists) {
		if (!destFolder.isFolder)
			return false;
		else {
			var destFiles = destFolder.getFiles();
			if (destFiles) {
				for (i=0; i<destFiles.length; i++)
					if (!destFiles[i].isFolder)
						destFiles[i].remove();
			}
		}
	}
	else {
		if (!destFolder.createFolder())
			return false;
	}

	var destBodyFilename = destFoldername + '/' + srcFilename.substring (srcFilename.lastIndexOf('/')+1, srcFilename.lastIndexOf('.'))+'.txt';
	// remove old...
	var destBodyFile = JSXFile (destBodyFilename);
	if (destBodyFile.exists)
		destBodyFile.remove();
	// copy new body into location...
	destBodyFile = JSXFile (srcFilename);
	if (!destBodyFile.copy (destBodyFilename))
		return false;
	destBodyFile = JSXFile (destBodyFilename); // bugfix

	// retrieve array of objects to fix html-source-code...
	var doc = destBodyFile.openMarkup();
	destBodyFile.close();
	if (!doc)
		return false;

	var dataRoot = '/'+destBodyFilename.substring (website.root.longUrl.length, destBodyFilename.lastIndexOf('/')+1); // 7 = 'file://'
	// foreground images...
	for (var j=0; j<doc.element.getSubElementCount('img'); j++) {
		var obj = doc.element.getSubElement('img', j);
		var dataFilename = obj.src.substring (obj.src.lastIndexOf('/')+1, obj.src.length);
		var newref = 'http://'+h2eServer.domainName.value + dataRoot + dataFilename;
		var copyFile = JSXFile (absoluteURL (obj.src, srcFilename));
		var destFilename = destFoldername+'/'+dataFilename;
		copyFile.copy (destFilename);
		obj.src = newref;
		if (sending && !upload2server (destFilename))
			return false;
	}
	// body background image...
	var obj = doc.element.getSubElement('body', 0);
	if (obj.background != undefined) {
		var dataFilename = obj.background.substring (obj.background.lastIndexOf('/')+1, obj.background.length);
		var newref = 'http://'+h2eServer.domainName.value + dataRoot + dataFilename;
		var copyFile = JSXFile (absoluteURL (obj.background, srcFilename));
		var destFilename = destFoldername+'/'+dataFilename;
		copyFile.copy (destFilename);
		obj.background = newref;
		if (sending && !upload2server (destFilename))
			return false;
	}
	// table background images...
	for (var j=0; j<doc.element.getSubElementCount('table'); j++) {
		var obj = doc.element.getSubElement('table', j);
		if (obj.background != undefined) {
			var dataFilename = obj.background.substring (obj.background.lastIndexOf('/')+1, obj.background.length);
			var newref = 'http://'+h2eServer.domainName.value + dataRoot + dataFilename;
			var copyFile = JSXFile (absoluteURL (obj.background, srcFilename));
			var destFilename = destFoldername+'/'+dataFilename;
			copyFile.copy (destFilename);
			obj.background = newref;
			if (sending && !upload2server (destFilename))
				return false;
		}
	}
	// cell background images...
	for (var j=0; j<doc.element.getSubElementCount('td'); j++) {
		var obj = doc.element.getSubElement('td', j);
		if (obj.background != undefined) {
			var dataFilename = obj.background.substring (obj.background.lastIndexOf('/')+1, obj.background.length);
			var newref = 'http://'+h2eServer.domainName.value + dataRoot + dataFilename;
			var copyFile = JSXFile (absoluteURL (obj.background, srcFilename));
			var destFilename = destFoldername+'/'+dataFilename;
			copyFile.copy (destFilename);
			obj.background = newref;
			if (sending && !upload2server (destFilename))
				return false;
		}
	}


	doc.reparse();
	doc.save();
	doc.close();

	var bound = '=_'+id(20);

	// header...
	if (h2eServer.writeHead.state) {
		var destHeadFilename = destFoldername + '/' + srcFilename.substring (srcFilename.lastIndexOf('/')+1, srcFilename.lastIndexOf('.'))+h2eServer.padHead.value+'.txt';
		var destHeadFile = JSXFile (destHeadFilename);
		if (destHeadFile.exists)
			destHeadFile.remove();
		destHeadFile = JSXFile (destHeadFilename);
		var headcode = 'Mime-Version: 1.0\n';
		headcode += 'Content-Type: multipart/related; boundary="'+bound+'"\n\n';
		if (destHeadFile.open('wb', 'BINARY')) {
			destHeadFile.write(headcode);
			destHeadFile.close();
		}
	}

	// html-body...
	var bodycode = '';
	var altcode = h2eServer.alternateText.value;
	if (altcode.length) {
		var subbound = '=_'+id(20);
		altcode += '\n\n';
		bodycode += qpencode(altcode)+'\n';
		bodycode += '--'+bound+'\n';
		bodycode += 'Content-Type: multipart/alternative; boundary="'+subbound+'"\n\n';
		bodycode += '--'+subbound+'\n';
		bodycode += 'Content-Type: text/plain; charset=ISO-8859-1\n';
		bodycode += 'Content-Transfer-Encoding: quoted-printable\n\n';
		bodycode += qpencode(altcode)+'\n';
		bodycode += '--'+subbound+'\n';
		bodycode += 'Content-Type: text/html; charset=ISO-8859-1\n';
	}
	else
		bodycode += '--'+bound+'\n';

	if (h2eServer.Encode.state) {
		bodycode += 'Content-Transfer-Encoding: base64\n\n';
		if (destBodyFile.open('rb', 'BINARY')) {
			bodycode += b64encode(destBodyFile.read())+'\n';
			destBodyFile.close();
		}
	}
	else {
		bodycode += 'Content-Transfer-Encoding: quoted-printable\n\n';
		if (destBodyFile.open('rb', 'BINARY')) {
			bodycode += '<!-- HTML2EMail start -->\n'+destBodyFile.read()+'\n<!-- HTML2EMail end -->\n\n';
			destBodyFile.close();
		}
	}

	if (altcode.length)
		bodycode += '--'+subbound+'--\n\n\n';

	bodycode += '--'+bound+'--\n';
	if (destBodyFile.open('wb', 'BINARY')) {
		destBodyFile.write(bodycode);
		destBodyFile.close();
	}

	// php...
	if (h2eServer.writeCode.state && h2eServer.to.value.length && h2eServer.subject.value.length) {
		var destCodeFilename = destFoldername + '/' + srcFilename.substring (srcFilename.lastIndexOf('/')+1, srcFilename.lastIndexOf('.'))+'_mail.php';
		var destCodeFile = JSXFile (destCodeFilename);
		if (destCodeFile.exists)
			destCodeFile.remove();
		var phpcode = '<?\n$mailBody = implode("", @file("'+destBodyFilename.substr (destBodyFilename.lastIndexOf('/')+1)+'"));\n';
		phpcode += 'mail ("'+h2eServer.to.value+'", "'+h2eServer.subject.value+'", $mailBody, "';
		if (h2eServer.from.value.length)
			phpcode += 'From: '+h2eServer.from.value+'\\nReply-To: '+h2eServer.from.value+'\\n';
		phpcode += 'Mime-Version: 1.0\\nContent-Type: multipart/related; boundary=\\"'+bound+'\\"\\n\\n");\n?>\n';
		destCodeFile = JSXFile (destCodeFilename);
		if (destCodeFile.open('wb', 'BINARY')) {
			destCodeFile.write(phpcode);
			destCodeFile.close();
		}
	}

	if (sending && !sendMail (destBodyFilename, h2eServer.from.value, h2eServer.to.value, h2eServer.subject.value, bound))
		return false;

	return true;
}

function upload2server (destFilename) {
	for (var fi=0; fi<fileList.length; fi++)
		if (destFilename == fileList[fi])
			return true;

	fileList.push (destFilename);
	var res = true;
	var site = document.website;
	var siteName = String (document.site.longUrl);
	if (site.currentServer) {
		var destFile = new JSXFile (destFilename);
		var server = site.currentServer;
		// prepare folders...
		var destPathname = destFilename.substr(siteName.length);
		var folders = destPathname.split ('/');
		var actPath = '';
		for (pidx=0; pidx<folders.length-1; pidx++) {
			var serverName = server.protocol+'://'+server.host+server.path+actPath;
			if ('ftp' == server.protocol)
				var serverFile = new JSXFTP (serverName, server.user, server.password);
			else
				var serverFile = new JSXDAV (serverName, server.user, server.password);
			if (!serverFile.connect ()) {
				alert ('Error connecting server!\n'+serverFile.lastError);
				return false;
			}
			serverFile.createFolder (folders[pidx]);
			serverFile.disconnect ();
			actPath += folders[pidx]+'/';
		}
		// copy file...
		var serverName = server.protocol+'://'+server.host+server.path+destFilename.substr(siteName.length);
		if ('ftp' == server.protocol)
			var serverFile = new JSXFTP (serverName, server.user, server.password);
		else
			var serverFile = new JSXDAV (serverName, server.user, server.password);
		res = serverFile.connect();
		if (res) {
			if (serverFile.exists) {
				res &= serverFile.remove();
				serverFile.disconnect ();
				if (server.protocol == 'ftp')
					var serverFile = new JSXFTP (serverName, server.user, server.password);
				else
					var serverFile = new JSXDAV (serverName, server.user, server.password);
				res = serverFile.connect();
			}
			app.setProgress (0, "Copy file '"+folders[folders.length-1]+"' to server...");
			res &= destFile.copy (serverFile);
		}
		serverFile.disconnect();
		$.gc();	// internal bug
		$.gc();
		if (!res)
			alert ('Error while uploading the file!\n'+res);
	}
	else
		res = false;
	return res;
}

function traverseServer (h2eCollection) {
	var result = true;
	var h2eRef = h2eCollection.first();
	while (h2eRef) {
		if (processBreak)
			break;
		switch (h2eRef.type) {
			case 'html':
				if (!processServer (h2eRef.longUrl))
					return false;
				break;

			case 'folder':
				result &= traverseServer (h2eRef.getFiles());
		}
		h2eRef = h2eCollection.next();
	}
	return result;
}